searchData={"items":[{"type":"module","title":"Slime","doc":"Slim-like HTML templates.","ref":"Slime.html"},{"type":"macro","title":"Slime.function_from_file/5","doc":"Generates a function definition from the file contents.\nThe kind (`:def` or `:defp`) must be given, the\nfunction name, its arguments and the compilation options.\nThis function is useful in case you have templates but\nyou want to precompile inside a module for speed.","ref":"Slime.html#function_from_file/5"},{"type":"macro","title":"Examples - Slime.function_from_file/5","doc":"# sample.slim\n    = a + b\n\n    # sample.ex\n    defmodule Sample do\n      require Slime\n      Slime.function_from_file :def, :sample, \"sample.slime\", [:a, :b]\n    end\n\n    # iex\n    Sample.sample(1, 2) #=> \"3\"","ref":"Slime.html#function_from_file/5-examples"},{"type":"macro","title":"Slime.function_from_string/5","doc":"Generates a function definition from the string.\nThe kind (`:def` or `:defp`) must be given, the\nfunction name, its arguments and the compilation options.","ref":"Slime.html#function_from_string/5"},{"type":"macro","title":"Examples - Slime.function_from_string/5","doc":"iex> defmodule Sample do\n    ...>   require Slime\n    ...>   Slime.function_from_string :def, :sample, \"= a + b\", [:a, :b]\n    ...> end\n    iex> Sample.sample(1, 2)\n    \"3\"","ref":"Slime.html#function_from_string/5-examples"},{"type":"function","title":"Slime.render/1","doc":"","ref":"Slime.html#render/1"},{"type":"function","title":"Slime.render/2","doc":"","ref":"Slime.html#render/2"},{"type":"module","title":"Slime.Compiler","doc":"Compile a tree of parsed Slime into EEx.","ref":"Slime.Compiler.html"},{"type":"function","title":"Slime.Compiler.compile/1","doc":"","ref":"Slime.Compiler.html#compile/1"},{"type":"function","title":"Slime.Compiler.hide_dialyzer_spec/1","doc":"","ref":"Slime.Compiler.html#hide_dialyzer_spec/1"},{"type":"module","title":"Slime.Doctype","doc":"Mapping doctype shorthands to their actual values.","ref":"Slime.Doctype.html"},{"type":"function","title":"Slime.Doctype.for/1","doc":"","ref":"Slime.Doctype.html#for/1"},{"type":"module","title":"Slime.Parser","doc":"Build a Slime tree from a Slime document.","ref":"Slime.Parser.html"},{"type":"function","title":"Slime.Parser.parse/1","doc":"","ref":"Slime.Parser.html#parse/1"},{"type":"module","title":"Slime.Parser.AttributesKeyword","doc":"Utilities for handling element attributes.","ref":"Slime.Parser.AttributesKeyword.html"},{"type":"function","title":"Slime.Parser.AttributesKeyword.merge/2","doc":"Merges multiply attributes values for keys specified in merge_rules.\nAttribute value may be given by string, list, or {:eex, args} node\n`merge_rules` should me an `%{attribute_name: joining_character}` map","ref":"Slime.Parser.AttributesKeyword.html#merge/2"},{"type":"function","title":"Examples - Slime.Parser.AttributesKeyword.merge/2","doc":"iex> Slime.Parser.AttributesKeyword.merge(\n    ...>   [class: \"a\", class: [\"b\", \"c\"], class: \"d\"],\n    ...>   %{class: \" \"}\n    ...> )\n    [class: \"a b c d\"]\n\n    iex> Slime.Parser.AttributesKeyword.merge(\n    ...>   [class: \"a\", class: [\"b\", \"c\"], class: {:eex, \"d\"}],\n    ...>   %{class: \" \"}\n    ...> )\n    [class: {:eex, ~S(\"a b c #{d}\")}]","ref":"Slime.Parser.AttributesKeyword.html#merge/2-examples"},{"type":"behaviour","title":"Slime.Parser.EmbeddedEngine","doc":"Embedded engine behaviour module.\nProvides basic logic of parsing slime with embedded parts for other engines.","ref":"Slime.Parser.EmbeddedEngine.html"},{"type":"function","title":"Slime.Parser.EmbeddedEngine.parse/2","doc":"","ref":"Slime.Parser.EmbeddedEngine.html#parse/2"},{"type":"callback","title":"Slime.Parser.EmbeddedEngine.render/2","doc":"","ref":"Slime.Parser.EmbeddedEngine.html#c:render/2"},{"type":"type","title":"Slime.Parser.EmbeddedEngine.engine_input/0","doc":"","ref":"Slime.Parser.EmbeddedEngine.html#t:engine_input/0"},{"type":"type","title":"Slime.Parser.EmbeddedEngine.parser_tag/0","doc":"","ref":"Slime.Parser.EmbeddedEngine.html#t:parser_tag/0"},{"type":"module","title":"Slime.Parser.EmbeddedEngine.Css","doc":"CSS engine callback module","ref":"Slime.Parser.EmbeddedEngine.Css.html"},{"type":"function","title":"Slime.Parser.EmbeddedEngine.Css.render/2","doc":"","ref":"Slime.Parser.EmbeddedEngine.Css.html#render/2"},{"type":"module","title":"Slime.Parser.EmbeddedEngine.EEx","doc":"EEx engine callback module","ref":"Slime.Parser.EmbeddedEngine.EEx.html"},{"type":"function","title":"Slime.Parser.EmbeddedEngine.EEx.render/2","doc":"","ref":"Slime.Parser.EmbeddedEngine.EEx.html#render/2"},{"type":"module","title":"Slime.Parser.EmbeddedEngine.Elixir","doc":"Elixir code engine callback module","ref":"Slime.Parser.EmbeddedEngine.Elixir.html"},{"type":"function","title":"Slime.Parser.EmbeddedEngine.Elixir.render/2","doc":"","ref":"Slime.Parser.EmbeddedEngine.Elixir.html#render/2"},{"type":"module","title":"Slime.Parser.EmbeddedEngine.Javascript","doc":"Javascript engine callback module","ref":"Slime.Parser.EmbeddedEngine.Javascript.html"},{"type":"function","title":"Slime.Parser.EmbeddedEngine.Javascript.render/2","doc":"","ref":"Slime.Parser.EmbeddedEngine.Javascript.html#render/2"},{"type":"module","title":"Slime.Parser.Nodes","doc":"","ref":"Slime.Parser.Nodes.html"},{"type":"module","title":"Slime.Parser.Nodes.DoctypeNode","doc":"A doctype node.\n\n:name is a Slim shorthand (e.g. \"xml\" or \"html\").","ref":"Slime.Parser.Nodes.DoctypeNode.html"},{"type":"module","title":"Slime.Parser.Nodes.EExNode","doc":"An embedded code node.\n\n* :content — embedded code,\n* :output — should the return value be inserted in the page,\n* :spaces — tag whitespace, represented as a keyword list of boolean\nvalues for :leading and :trailing,\n* :children — a list of nodes.\n* :safe? - mark output as safe for html-escaping engines","ref":"Slime.Parser.Nodes.EExNode.html"},{"type":"module","title":"Slime.Parser.Nodes.HTMLCommentNode","doc":"An HTML comment node.\n\nSimilar to `Slime.Parser.Nodes.VerbatimTextNode`.","ref":"Slime.Parser.Nodes.HTMLCommentNode.html"},{"type":"module","title":"Slime.Parser.Nodes.HTMLNode","doc":"An HTML node.\n\n* :name — tag name,\n* :attributes — a list of {\"name\", :v} tuples, where :v is\neither a string or an {:eex, \"content\"} tuple,\n* :spaces — tag whitespace, represented as a keyword list of boolean\nvalues for :leading and :trailing,\n* :closed — the presence of a trailing \"/\", which explicitly closes the tag,\n* :children — a list of nodes.","ref":"Slime.Parser.Nodes.HTMLNode.html"},{"type":"module","title":"Slime.Parser.Nodes.InlineHTMLNode","doc":"An inline HTML node.\n\nSimilar to `Slime.Parser.Nodes.VerbatimTextNode`, with the exeption\nof :children field, which represents a list of nodes indented deeper\nthan the HTML content.","ref":"Slime.Parser.Nodes.InlineHTMLNode.html"},{"type":"module","title":"Slime.Parser.Nodes.VerbatimTextNode","doc":"A verbatim text node.\n\n* :content — a list of strings and %EExNode{} structs that\nis concatenated during rendering. No newlines or spaces\nare inserted between individual items.","ref":"Slime.Parser.Nodes.VerbatimTextNode.html"},{"type":"module","title":"Slime.Parser.Preprocessor","doc":"This module helps to process input and insert indents and dedents to simplify parser design.","ref":"Slime.Parser.Preprocessor.html"},{"type":"function","title":"Slime.Parser.Preprocessor.dedent_meta_symbol/0","doc":"","ref":"Slime.Parser.Preprocessor.html#dedent_meta_symbol/0"},{"type":"function","title":"Slime.Parser.Preprocessor.indent/1","doc":"Takes an input binary and inserts virtual indent and dedent.","ref":"Slime.Parser.Preprocessor.html#indent/1"},{"type":"function","title":"Examples: - Slime.Parser.Preprocessor.indent/1","doc":"iex> Slime.Parser.Preprocessor.indent(\"t\\n p\")\n    \"t\\n\u000E p\u000F\"\n\n    iex> Slime.Parser.Preprocessor.indent(\"t\\n p\\n  a\\nh\")\n    \"t\\n\u000E p\\n\u000E  a\u000F\u000F\\nh\"","ref":"Slime.Parser.Preprocessor.html#indent/1-examples"},{"type":"function","title":"Slime.Parser.Preprocessor.indent_meta_symbol/0","doc":"","ref":"Slime.Parser.Preprocessor.html#indent_meta_symbol/0"},{"type":"function","title":"Slime.Parser.Preprocessor.indent_size/1","doc":"Counts indent size by indent string using :tab_size config option","ref":"Slime.Parser.Preprocessor.html#indent_size/1"},{"type":"function","title":"Examples: - Slime.Parser.Preprocessor.indent_size/1","doc":"iex> Slime.Parser.Preprocessor.indent_size(\"    \")\n    4\n\n    iex> Slime.Parser.Preprocessor.indent_size(\"  \t\")\n    4\n\n    iex> Slime.Parser.Preprocessor.indent_size(\"\")\n    0","ref":"Slime.Parser.Preprocessor.html#indent_size/1-examples"},{"type":"function","title":"Slime.Parser.Preprocessor.process/1","doc":"","ref":"Slime.Parser.Preprocessor.html#process/1"},{"type":"function","title":"Slime.Parser.Preprocessor.remove_trailing_spaces/1","doc":"Removes trailing whitespace, leaving newlines intact.","ref":"Slime.Parser.Preprocessor.html#remove_trailing_spaces/1"},{"type":"module","title":"Slime.Parser.TextBlock","doc":"Utilities for parsing text blocks.","ref":"Slime.Parser.TextBlock.html"},{"type":"function","title":"Slime.Parser.TextBlock.render_content/2","doc":"Given a text block and its declaration indentation level (see below),\nproduces a string (or a dynamic EEx tuple) that can be inserted into the tree.\n\nnested\n  | Text block\n     that spans over multiple lines\n---\n ^\ndeclaration indent","ref":"Slime.Parser.TextBlock.html#render_content/2"},{"type":"function","title":"Slime.Parser.TextBlock.render_without_indentation/1","doc":"Given a text block, returns the text without indentation.","ref":"Slime.Parser.TextBlock.html#render_without_indentation/1"},{"type":"module","title":"Slime.Parser.Transform","doc":"PEG parser callbacks module.\nDefine transformations from parsed iolist to ast.\nSee https://github.com/seancribbs/neotoma/wiki#working-with-the-ast","ref":"Slime.Parser.Transform.html"},{"type":"function","title":"Slime.Parser.Transform.expand_shortcut/2","doc":"","ref":"Slime.Parser.Transform.html#expand_shortcut/2"},{"type":"function","title":"Slime.Parser.Transform.expand_tag_shortcut/1","doc":"","ref":"Slime.Parser.Transform.html#expand_tag_shortcut/1"},{"type":"function","title":"Slime.Parser.Transform.newlines/1","doc":"","ref":"Slime.Parser.Transform.html#newlines/1"},{"type":"function","title":"Slime.Parser.Transform.transform/3","doc":"","ref":"Slime.Parser.Transform.html#transform/3"},{"type":"type","title":"Slime.Parser.Transform.ast/0","doc":"","ref":"Slime.Parser.Transform.html#t:ast/0"},{"type":"type","title":"Slime.Parser.Transform.index/0","doc":"","ref":"Slime.Parser.Transform.html#t:index/0"},{"type":"module","title":"Slime.Renderer","doc":"Transform Slime templates into HTML.","ref":"Slime.Renderer.html"},{"type":"function","title":"Slime.Renderer.precompile/1","doc":"Compile Slime template to valid EEx HTML.","ref":"Slime.Renderer.html#precompile/1"},{"type":"function","title":"Examples - Slime.Renderer.precompile/1","doc":"iex> Slime.Renderer.precompile(~s(input.required type=\"hidden\"))\n    \" \"","ref":"Slime.Renderer.html#precompile/1-examples"},{"type":"function","title":"Slime.Renderer.render/3","doc":"Takes a Slime template as a string as well as a set of bindings, and renders\nthe resulting HTML.\n\nNote that this method of rendering is substantially slower than rendering\nprecompiled templates created with Slime.function_from_file/5 and\nSlime.function_from_string/5.","ref":"Slime.Renderer.html#render/3"},{"type":"exception","title":"Slime.TemplateSyntaxError","doc":"Syntax exception which may appear during parsing and compilation processes","ref":"Slime.TemplateSyntaxError.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}